/**
 * AGUA Copyright (C) 2023  Atix Labs
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

@import 'css/variables';
@import 'css/_general_styling.scss';

.coaButton {
  display: inline-flex;
  align-items: center;
  justify-content: center;

  &.--withDefaultHeight {
    height: 2.375rem;
  }

  &.ghost {
    * {
      @include primary-text(0.875rem, $coa-button-text-ghost-color, 500);
    }
    border: 1px solid $coa-button-border-ghost-color;
    background: $coa-button-ghost-background;
    border-radius: 4px;
    display: flex;
    justify-content: center;
    align-items: center;

    &.--disabled {
      opacity: 0.2;
      background: $coa-button-disabled-background;
      * {
        color: $coa-button-ghost-disabled-text-color;
      }
      &:hover {
        background: $coa-button-disabled-hover-background;
      }
    }
  }

  &.ghost-dark {
    * {
      @include primary-text(0.875rem, $coa-button-text-ghost-dark-color, 500);
    }

    border: 1px solid $coa-button-border-ghost-dark-color;
    background: $coa-button-ghost-background;
    border-radius: 4px;
    display: flex;
    justify-content: center;
    align-items: center;

    &.--disabled {
      opacity: 0.2;
      background: $coa-button-disabled-background;
      * {
        color: $coa-button-ghost-disabled-text-color;
      }
      &:hover {
        background: $coa-button-disabled-hover-background;
      }
    }
  }

  &.primary {
    background: $coa-button-background-primary;
    border-color: $coa-button-border-primary;
    * {
      color: $white;
    }

    &.--disabled {
      opacity: 0.4;
      background: $coa-button-background-primary-disabled;

      &:hover {
        background: $coa-button-background-primary-disabled-hover;
      }
    }
  }

  &.secondary {
    background: $coa-button-background-secondary;
    border-color: $coa-button-border-secondary;
    * {
      color: $coa-button-secondary-text-color;
    }

    &.--disabled {
      opacity: 0.4;
      background: $coa-button-background-secondary-disabled;
      * {
        color: $white;
      }
      &:hover {
        background: $coa-button-background-secondary-disabled-hover;
      }
    }
  }

  &.dark {
    background: $coa-button-background-dark;
    * {
      color: $coa-button-dark-text-color;
      font-weight: 500;
    }

    &.--disabled {
      opacity: 0.2;
      background: $coa-button-background-dark-disabled;
      * {
        color: $coa-button-dark-text-color;
      }

      &:hover {
        background: $coa-button-background-dark-disabled-hover;
      }
    }
  }

  &.danger {
    background: $button-danger-background;
    border-color: $button-danger-background;
    * {
      color: $button-danger-text-color;
      font-weight: 500;
    }

    &.--disabled {
      opacity: 0.2;
      background: $button-danger-background-disabled;
      * {
        color: $button-danger-text-color;
      }

      &:hover {
        background: $button-danger-background-disabled-hover;
      }
    }
  }

  &.success {
    background: $button-success-background;
    border-color: $button-success-background;
    * {
      color: $button-success-text-color;
      font-weight: 500;
    }

    &.--disabled {
      opacity: 0.2;
      background: $button-success-background-disabled;
      * {
        color: $button-success-text-color;
      }

      &:hover {
        background: $button-success-background-disabled-hover;
      }
    }
  }

  &.--fullWidth {
    width: 100%;
  }
}
